diff options
author | Paul Eggert <eggert@cs.ucla.edu> | 2004-09-24 23:34:07 +0000 |
---|---|---|
committer | Paul Eggert <eggert@cs.ucla.edu> | 2004-09-24 23:34:07 +0000 |
commit | 83674d774d8087ae84e33c4356eb9e99ecd826b9 (patch) | |
tree | a9e1029dd4d3922506a7852e4f7e23007c85ad70 /tests/chmod/usage | |
parent | 4f5ed75ee4f56c6d0dc30d88fed5119f31517a27 (diff) | |
download | coreutils-83674d774d8087ae84e33c4356eb9e99ecd826b9.tar.gz coreutils-83674d774d8087ae84e33c4356eb9e99ecd826b9.tar.bz2 coreutils-83674d774d8087ae84e33c4356eb9e99ecd826b9.zip |
Initial revision
Diffstat (limited to 'tests/chmod/usage')
-rwxr-xr-x | tests/chmod/usage | 90 |
1 files changed, 90 insertions, 0 deletions
diff --git a/tests/chmod/usage b/tests/chmod/usage new file mode 100755 index 000000000..cc807c81b --- /dev/null +++ b/tests/chmod/usage @@ -0,0 +1,90 @@ +#!/bin/sh +# Verify that chmod works correctly with odd option combinations. + +if test "$VERBOSE" = yes; then + set -x + chmod --version +fi + +. $srcdir/../lang-default + +pwd=`pwd` +tmp=equals.$$ +trap 'status=$?; cd $pwd; rm -rf $tmp && exit $status' 0 +trap '(exit $?); exit' 1 2 13 15 + +framework_failure=0 +mkdir $tmp || framework_failure=1 +cd $tmp || framework_failure=1 + +if test $framework_failure = 1; then + echo "$0: failure in testing framework" 1>&2 + (exit 1); exit 1 +fi + +fail=0 + +# Each line in this list is a set of arguments, followed by :, +# followed by the set of files it will attempt to chmod, +# or empty if the usage is erroneous. +# Many of these test cases are due to Glenn Fowler. +# These test cases assume GNU behavior for "options" like -w. +cases=' + -- : + -- -- : + -- -- -- f : -- f + -- -- -w f : -w f + -- -- f : f + -- -w : + -- -w -- f : -- f + -- -w -w f : -w f + -- -w f : f + -- f : + -w : + -w -- : + -w -- -- f : -- f + -w -- -w f : -w f + -w -- f : f + -w -w : + -w -w -- f : f + -w -w -w f : f + -w -w f : f + -w f : f + f : + f -- : + f -w : f + f f : +' + +all_files=`echo "$cases" | sed 's/.*://'` + +old_IFS=$IFS +IFS=' +' +for case in $cases; do + IFS=$old_IFS + args=`expr "$case" : ' *\(.*[^ ]\) *:'` + files=`expr "$case" : '.*: *\(.*\)'` + + case $files in + '') + touch -- $all_files || framework_failure=1 + chmod $args 2>/dev/null && fail=1 + ;; + ?*) + touch -- $files || framework_failure=1 + chmod $args || fail=1 + for file in $files; do + rm -f -- $files && touch -- $files && rm -- $file || framework_failure=1 + chmod $args 2>/dev/null && fail=1 + done + ;; + esac +done + +if test $framework_failure = 1; then + echo "$0: failure in testing framework" 1>&2 + fail=1 +fi + +(exit $fail); exit $fail |